#include <msp430x16x.h>
#include  "clock.h"
#include  "ISD4004_SPI.h"
#include  "LCD.h"
#include  "extern.h"
/*********************************************/
#define  ISD_IO   P3DIR
#define  ISD_OUT  P3OUT
#define  ISD_IN   P3IN
#define  CSS_L   ISD_OUT &= ~BIT0      //  RW enable low
#define  CSS_H   ISD_OUT |= BIT0       //  RW enable high
#define  MOSI_L  ISD_OUT &= ~BIT1      //  date  output low 
#define  MOSI_H  ISD_OUT |= BIT1       //  date  output high
#define  SCLK_L  ISD_OUT &= ~BIT2      //  clock set low
#define  SCLK_H  ISD_OUT |= BIT2       //  clock set  high
#define  MISO    BIT3

/**************IO initialization******************************/
void ISD_io_int(void)
{
  ISD_IO |= BIT0 + BIT1 + BIT2;
  
  SCLK_L;
  CSS_L;
  MOSI_L;

}
/*************** RW temperature Register**********************************/
void ISD_SPI_Write(unsigned char command, unsigned int addr )
{ 
 
  char i;
 
   CSS_H;
   SCLK_L;
   CSS_L;
   
  for(i = 0;i < 16;i++) 
 {     
    if(addr & 0x0001) MOSI_H;
           else MOSI_L;
       addr >>= 1;
    
       SCLK_H;
       _NOP(); _NOP(); 
       SCLK_L; 
       _NOP();
 } 
   
   
   for(i = 0;i < 8;i++) 
 {    
       if(command & 0x01) MOSI_H;
           else MOSI_L;
        command >>= 1;
       
        SCLK_H;
        _NOP();_NOP(); 
         SCLK_L; 
        _NOP();
 } 
  CSS_H;  
  SCLK_L;
}

/********************************************/
void  ISD_Write(unsigned char command )
{  char i;
 
   CSS_H;
   SCLK_L;
   CSS_L;
   
 for(i = 0;i < 8;i++) 
 {    
       if(command & 0x01) MOSI_H;
           else MOSI_L;
        command >>= 1;
        SCLK_H;
       _NOP();_NOP();
        SCLK_L; 
        _NOP();
 } 
   CSS_H;  
   SCLK_L;
} 
/*******************************************/
void  ISD_Record_Time( unsigned int addr, unsigned int time)
{ 
   ISD_SPI_Write(ISDPOWERUP,0);
    delayms(20);
   ISD_SPI_Write(ISDPOWERUP,0);
    delayms(40);
   ISD_SPI_Write(RECSET, addr);
   ISD_SPI_Write(REC,0);
   delays(time);
   ISD_SPI_Write(OPERSTOP,0);
   delayms(40);
}
/****************************************/
void  ISD_Play_Time( unsigned int addr, unsigned int time )
{ 
   ISD_SPI_Write(ISDPOWERUP,0);
   delayms(20);
   ISD_SPI_Write(PLAYSET, addr);
   ISD_SPI_Write(PLAY,0);
   delays(time);
   ISD_SPI_Write(OPERSTOP,0);
   delayms(40);
}
/*******************************************/
void  ISD_Record( unsigned int addr)
{ 
   ISD_SPI_Write(ISDPOWERUP,0);
    delayms(20);
   ISD_SPI_Write(ISDPOWERUP,0);
    delayms(40);
   ISD_SPI_Write(RECSET, addr);
   ISD_SPI_Write(REC,0);
   delayms(40);
}
/****************************************/
void  ISD_Play( unsigned int addr)
{ 
   ISD_SPI_Write(ISDPOWERUP,0);
   delayms(20);
   ISD_SPI_Write(PLAYSET, addr);
   ISD_SPI_Write(PLAY,0);
   delayms(40);
}

void ISD_Stop(void)
{
   ISD_SPI_Write(OPERSTOP,0);
   delayms(40);
}


void ISD_record(void)//¼
{
 delayms(10);
 disp_str(1,1,"1 ¼");
 while(1)
 {
  if(Key_Val==1)
  {
   Key_Val=0; 
    break;
  }    
 }
 disp_str(1,1,"¼...");
 ISD_Record_Time(0x00,4);
 Address[0]=0x00;//¼һοʼַ
 Address[1]=0x16;//¼һνַ
 disp_str(1,1,"¼...");
 disp_str(1,2,"2 ¼");
 while(1)
 {
  if(Key_Val==2)
  {
   Key_Val=0;
    Write_Cmd(0x01);//Һ
    break;
  }    
 } 
 disp_str(1,1,"¼...");
 ISD_Record_Time(Address[1],4);
 Address[2]=0x32;//¼ڶνַ
 disp_str(1,1,"¼...");
 disp_str(1,2,"3 ¼");
 while(1)
 {
  if(Key_Val==3)
  {
   Key_Val=0;
    Write_Cmd(0x01);//Һ
    break;
  }    
 }  
 disp_str(1,1,"¼...");
 ISD_Record_Time(Address[2],4); 
 Address[3]=0x48;//¼νַ
 disp_str(1,1,"¼...");
 disp_str(1,2,"4 ¼");
 while(1)
 {
  if(Key_Val==4)
  {
   Key_Val=0;
    Write_Cmd(0x01);//Һ
    break;
  }    
 }  
 disp_str(1,1,"¼...");
 ISD_Record_Time(Address[3],4); 
 Address[4]=0x64;//¼Ķνַ 
 disp_str(1,1,"¼...");
 disp_str(1,2,"ѡط");
 while(1)
  {
    switch( Key_Val)
    {
      case 1:
      {
        ISD_Play_Time(Address[0],4);
        break;
      }
        case 2:
      {
        ISD_Play_Time(Address[1],4);
        break;
      }
       case 3:
      {
        ISD_Play_Time(Address[2],4);
        break;
      }
       case 4:
      {
        ISD_Play_Time(Address[3],4);
        break;
      }
    default :break;
    }
  }
   
}